﻿
function Lifebloomer_OnLoad()
	SlashCmdList["LIFEBLOOMER"] = Lifebloomer_SlashCommand;
	SLASH_LIFEBLOOMER1 = "/Lifebloomer";
	SLASH_LIFEBLOOMER2 = "/lifebloomer";
	SLASH_LIFEBLOOMER3 = "/LB";
	SLASH_LIFEBLOOMER4 = "/Lb";
	SLASH_LIFEBLOOMER5 = "/lb";
	LBVplayername, LBVrealm = UnitName("player");
	loc, LBVClass = UnitClass("player");
	LBVLevel = UnitLevel("player");
	LBVersion = "1.6.1";
	LB_GCD_Time = 1.5;
	LBVFF = 0;
	
	if LBVClass == "DRUID" then
		LB_GCD = true;
	else
		LB_GCD = false;
	end
	
	LifebloomerMainFrameUnitFrame1.Number = LifebloomerMainFrameUnitFrame1LBBarNumber;
	LifebloomerMainFrameUnitFrame1.Timer = LifebloomerMainFrameUnitFrame1LBBarTimer;
	LifebloomerMainFrameUnitFrame1.LBBar = LifebloomerMainFrameUnitFrame1LBBar;
	LifebloomerMainFrameUnitFrame1.LBBarGCD = LifebloomerMainFrameUnitFrame1LBBarGCD;
	LifebloomerMainFrameUnitFrame1.RejuvBar = LifebloomerMainFrameUnitFrame1RejuvBar;
	LifebloomerMainFrameUnitFrame1.RegroBar = LifebloomerMainFrameUnitFrame1RegroBar;
	LifebloomerMainFrameUnitFrame1.WildBar = LifebloomerMainFrameUnitFrame1WildBar;
	LifebloomerMainFrameUnitFrame1.HPBar = LifebloomerMainFrameUnitFrame1HPBar;
	LifebloomerMainFrameUnitFrame1.Name = LifebloomerMainFrameUnitFrame1HPBarName;
	LifebloomerMainFrameUnitFrame1.DTPSlabel = LifebloomerMainFrameUnitFrame1HPBarDTPS;
	LifebloomerMainFrameUnitFrame1.DTPS = 0;
	LifebloomerMainFrameUnitFrame1.Damage = 0;
	LifebloomerMainFrameUnitFrame1.TimeCount = 0;
	LifebloomerMainFrameUnitFrame1.Dmg = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	LifebloomerMainFrameUnitFrame1.LBTimer = 0;
	LifebloomerMainFrameUnitFrame1.RejuvTimer = 0;
	LifebloomerMainFrameUnitFrame1.RegroTimer = 0;
	LifebloomerMainFrameUnitFrame1.WildTimer = 0;
	LifebloomerMainFrameUnitFrame1.LBMax = 7;
	LifebloomerMainFrameUnitFrame1.RejuvMax = 12;
	LifebloomerMainFrameUnitFrame1.RegroMax = 21;
	LifebloomerMainFrameUnitFrame1.WildMax = 7;
	
	ClickCastFrames = ClickCastFrames or {};
	ClickCastFrames[LifebloomerMainFrameUnitFrame1] = true;
	
	LB_Buffer = {};
	Lifebloomer_OnLoad_Bindings();
	Lifebloomer_OnLoad_Handlers();
	
	if LBV and LBSaved.FTar == 1 then
		LBV_t = Lifebloomer_deepcopy(LBV);
		LBV = {};
		LBV[1] = {};
		LBV[1].Unitid = "target";
		LBV[1].Name = "target";
		LBV[1].Target2 = "targettargettarget";
		n = getn(LBV_t);
		if n>1 then
			for i = 2, n, 1 do
				Lifebloomer_AddFrame(getglobal("LifebloomerMainFrameUnitFrame"..(i-1)));
			end
		elseif n==0 then
			LBV = {};
			LBV[1] = {};
			LBV[1].Unitid = "target";
			LBV[1].Name = "target";
			LBV[1].Target2 = "targettargettarget";
			Lifebloomer_RemoveFrame(LifebloomerMainFrameUnitFrame1);
		end
		LBV = Lifebloomer_deepcopy(LBV_t);
		for i=1, n, 1 do
			Set_LBTarget(nil, LBV[i].Unitid, getglobal("LifebloomerMainFrameUnitFrame"..i));
		end
	else
		LBV = {};
		LBV[1] = {};
		LBV[1].Unitid = "target";
		LBV[1].Name = "target";
		LBV[1].Target2 = "targettargettarget";
	end
	
	Lifebloomer_OnLoad_Colors();
	Lifebloomer_OnLoad_Dimensions();
	
	if LBSaved.Vis then
		LifebloomerMainFrame:Show();
	end
	
	if LBSaved.LStat == 1 and LBSaved.Lock then
		LBSaved.Lock = nil;
		Lifebloomer_SlashCommand("lock");
	end
	
	Lifebloomer_SetAttributes(LifebloomerMainFrameUnitFrame1);
	Lifebloomer_SetHandlerAttributes(LifebloomerMainFrameUnitFrame1);
	
	InterfaceOptionsFrame:SetMovable(true);
	InterfaceOptionsFrame:RegisterForDrag("LeftButton");
	InterfaceOptionsFrame:SetScript("OnDragStart", function() InterfaceOptionsFrame:StartMoving(); end);
	InterfaceOptionsFrame:SetScript("OnMouseUp", function() InterfaceOptionsFrame:StopMovingOrSizing(); InterfaceOptionsFrame:SetUserPlaced(false); end);
	InterfaceOptionsFrame:SetScript("OnDragStop", function() InterfaceOptionsFrame:StopMovingOrSizing(); InterfaceOptionsFrame:SetUserPlaced(false); end);
	
	DEFAULT_CHAT_FRAME:AddMessage("Lifebloomer Loaded.  Type |cFFFFFFFF/lifebloomer|r for help.", 0, 1, 0);
end

function Lifebloomer_UnitFrame_OnEnter(self)
	if ( SpellIsTargeting() ) then
		SetCursor("CAST_CURSOR");
	end
	local unitid = self:GetAttribute("unit");
	if ( SpellIsTargeting() and not SpellCanTargetUnit(unitid) ) then
		SetCursor("CAST_ERROR_CURSOR");
	end
end

function Set_LBTarget(tar, unit, parent)
	if unit == 0 then
		unit = Lifebloomer_ID_Unit(tar);
	end
	if ( not ( unit == nil ) ) then
		local id = (parent):GetID();
		LBV[id].Unitid = unit;
		if not InCombatLockdown() then
			(parent):SetAttribute("unit", unit);
		end
		if strsub(unit, 1, 6) == "player" or strsub(unit, 1, 6) == "target" or strsub(unit, 1, 5) == "focus" or strsub(unit, 1, 9) == "mouseover" or strsub(unit, 1, 3) == "pet" or strsub(unit, 1, 5) == "party" then
			LBV[id].Target2 = unit.."targettarget";
		else
			LBV[id].Target2 = Lifebloomer_UnitRaidIndex(unit).."targettarget";
		end
	end
end

function Lifebloomer_UnitRaidIndex(unit)
	if UnitInRaid(unit) then
		for i = 1, 40, 1 do
			if UnitIsUnit(unit, "raid"..i) then
				return "raid"..i;
			end
		end
	elseif UnitInParty(unit) then
		for i = 1, 4, 1 do
			if UnitIsUnit(unit, "party"..i) then
				return "party"..i;
			end
		end
	else
		return unit;
	end
end

function Lifebloomer_Buff_Update(self, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, auraType, amount)
	--DEFAULT_CHAT_FRAME:AddMessage(event..tostring(sourceName)..tostring(destName)..tostring(spellName)..tostring(amount));
	local unit = LBV[self:GetID()].Unitid;
	if event == "LifebloomerTrigger" then
		local now = GetTime();
		local down, up, lag = GetNetStats();
		local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff(unit, LIFEBLOOMER_Lifebloom, nil, "PLAYER");
		if isMine then
			self.LBTimer = expirationTime - now - lag/1000;
			self.LBMax = duration;
			self.Number:SetText(count);
			self.LBBarGCD:SetPoint("TOP", self.LBBar, "TOPLEFT", (LBDim.w-10)/self.LBMax*LB_GCD_Time, -1);
			self.LBBarGCD:SetPoint("BOTTOM", self.LBBar, "BOTTOMLEFT", (LBDim.w-10)/self.LBMax*LB_GCD_Time, 1);
			self.LBBarGCD:Show();
		else
			self.LBTimer = 0;
			self.Number:SetText("");
			self.LBBarGCD:Hide();
		end
		local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff(unit, LIFEBLOOMER_Rejuvenation, nil, "PLAYER");
		if isMine then
			self.RejuvTimer = expirationTime - now - lag/1000;
			self.RejuvMax = duration;
		else
			self.RejuvTimer = 0;
		end
		local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff(unit, LIFEBLOOMER_Regrowth, nil, "PLAYER");
		if isMine then
			self.RegroTimer = expirationTime - now - lag/1000;
			self.RegroMax = duration;
		else
			self.RegroTimer = 0;
		end
		local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff(unit, LIFEBLOOMER_Wild_Growth, nil, "PLAYER");
		if isMine then
			self.WildTimer = expirationTime - now - lag/1000;
			self.WildMax = duration;
		else
			self.WildTimer = 0;
		end
	--debuff
		local curse = 0;
		local poison = 0;
		for i = 1, 40, 1 do
			if UnitExists(unit) then
				local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff(unit, i);
				if name == nil then
					break;
				elseif debuffType == "Curse" then
					curse = 1;
				elseif debuffType == "Poison" then
					poison = 1;
				end
			end
		end
		if curse == 1 and poison == 1 then
			self:SetBackdropBorderColor(LBColors[9].R, LBColors[9].G, LBColors[9].B, LBColors[9].A);
		elseif curse == 1 then
			self:SetBackdropBorderColor(LBColors[7].R, LBColors[7].G, LBColors[7].B, LBColors[7].A);
		elseif poison == 1 then
			self:SetBackdropBorderColor(LBColors[8].R, LBColors[8].G, LBColors[8].B, LBColors[8].A);
		else self:SetBackdropBorderColor(LBColors[6].R, LBColors[6].G, LBColors[6].B, LBColors[6].A);
		end
	elseif spellName == LIFEBLOOMER_Lifebloom then
		local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff(unit, LIFEBLOOMER_Lifebloom, nil, "PLAYER");
		if isMine then
			local now = GetTime();
			local down, up, lag = GetNetStats();
			self.LBTimer = expirationTime - now - lag/1000;
			self.LBMax = duration;
			self.Number:SetText(count);
			if event == "SPELL_AURA_APPLIED" then
				_, LB_GCD_Time, _ = GetSpellCooldown(spellName);
			end
			self.LBBarGCD:SetPoint("TOP", self.LBBar, "TOPLEFT", (LBDim.w-10)/self.LBMax*LB_GCD_Time, -1);
			self.LBBarGCD:SetPoint("BOTTOM", self.LBBar, "BOTTOMLEFT", (LBDim.w-10)/self.LBMax*LB_GCD_Time, 1);
			self.LBBarGCD:Show();
		else
			self.LBTimer = 0;
			self.Number:SetText("");
			self.LBBarGCD:Hide();
		end
	elseif spellName == LIFEBLOOMER_Rejuvenation then
		local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff(unit, LIFEBLOOMER_Rejuvenation, nil, "PLAYER");
		if isMine then
			local now = GetTime();
			local down, up, lag = GetNetStats();
			self.RejuvTimer = expirationTime - now - lag/1000;
			self.RejuvMax = duration;
		else
			self.RejuvTimer = 0;
		end
	elseif spellName == LIFEBLOOMER_Regrowth then
		local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff(unit, LIFEBLOOMER_Regrowth, nil, "PLAYER");
		if isMine then
			local now = GetTime();
			local down, up, lag = GetNetStats();
			self.RegroTimer = expirationTime - now - lag/1000;
			self.RegroMax = duration;
		else
			self.RegroTimer = 0;
		end
	elseif spellName == LIFEBLOOMER_Wild_Growth then
		local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff(unit, LIFEBLOOMER_Wild_Growth, nil, "PLAYER");
		if isMine then
			local now = GetTime();
			local down, up, lag = GetNetStats();
			self.WildTimer = expirationTime - now - lag/1000;
			self.WildMax = duration;
		else
			self.WildTimer = 0;
		end
	else	--debuff
		local curse = 0;
		local poison = 0;
		for i = 1, 40, 1 do
			if UnitExists(unit) then
				local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff(unit, i);
				if name == nil then
					break;
				elseif debuffType == "Curse" then
					curse = 1;
				elseif debuffType == "Poison" then
					poison = 1;
				end
			end
		end
		if curse == 1 and poison == 1 then
			self:SetBackdropBorderColor(LBColors[9].R, LBColors[9].G, LBColors[9].B, LBColors[9].A);
		elseif curse == 1 then
			self:SetBackdropBorderColor(LBColors[7].R, LBColors[7].G, LBColors[7].B, LBColors[7].A);
		elseif poison == 1 then
			self:SetBackdropBorderColor(LBColors[8].R, LBColors[8].G, LBColors[8].B, LBColors[8].A);
		else self:SetBackdropBorderColor(LBColors[6].R, LBColors[6].G, LBColors[6].B, LBColors[6].A);
		end
	end
end

function Lifebloomer_UnitHealth_Update(self, elapsed)
	local unit = LBV[self:GetID()].Unitid;
	self.HPBar:SetValue(UnitHealth(unit)/(UnitHealthMax(unit)+0.01));
end

function Lifebloomer_UnitFrame_Update(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
	if self.LBTimer > 0 then
		self.LBTimer = self.LBTimer - elapsed;
	end
	if self.RejuvTimer > 0 then
		self.RejuvTimer = self.RejuvTimer - elapsed;
	end
	if self.RegroTimer > 0 then
		self.RegroTimer = self.RegroTimer - elapsed;
	end
	if self.WildTimer > 0 then
		self.WildTimer = self.WildTimer - elapsed;
	end
	if self.TimeSinceLastUpdate > 0.05 then
		while self.TimeSinceLastUpdate > 0.05 do
			self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - 0.05;
			self.TimeCount = self.TimeCount + 1;
			if self.TimeCount >= 10 then
				if LBSaved.DTPS == 1 then
					Lifebloomer_DamageTakenUpdate1(self);
				elseif LBSaved.DTPS == 2 then
					Lifebloomer_DamageTakenUpdate2(self);
				end
				self.TimeCount = self.TimeCount - 10;
			end
		end
		local id = self:GetID();
		local down, up, lag = GetNetStats();
		local unit = LBV[id].Unitid;
		local name, realm = UnitName(unit);
		if not ( realm == LBVrealm ) then
			name = name.."-"..realm;
		end
		if unit == name then
			LBV[id].Target2 = Lifebloomer_UnitRaidIndex(unit).."targettarget";
		end
		
		if name == self.Name:GetText() then
		elseif name then
			self.Name:SetText(name);
			LBV[self:GetID()].Name = name;
			Lifebloomer_Buff_Update(self, "LifebloomerTrigger");
		else
			self.Name:SetText(unit);
		end
		
		if IsSpellInRange(LIFEBLOOMER_Healing_Touch, unit) == 1 then
			self.Name:SetTextColor(LBColors[10].R, LBColors[10].G, LBColors[10].B, LBColors[10].A);
		else
			self.Name:SetTextColor(LBColors[11].R, LBColors[11].G, LBColors[11].B, LBColors[11].A);
		end
		
		self.LBBar:SetValue(self.LBTimer/self.LBMax);
		self.RejuvBar:SetValue(self.RejuvTimer/self.RejuvMax);
		self.RegroBar:SetValue(self.RegroTimer/self.RegroMax);
		self.WildBar:SetValue(self.WildTimer/self.WildMax);
		
		if self.LBTimer <=0 then
			self.Timer:SetText("");
			self.Number:SetText("");
			self.LBBarGCD:Hide();
		else
			self.Timer:SetText(floor(self.LBTimer*10)/10);
			if self.LBTimer + lag/1000 < 1 then
				self.LBBar:SetStatusBarColor(.75, 0, 0, LBColors[3].A);
			elseif self.LBTimer < 1 then
				self.LBBar:SetStatusBarColor(.5, 0, .5, LBColors[3].A);
			else self.LBBar:SetStatusBarColor(LBColors[3].R, LBColors[3].G, LBColors[3].B, LBColors[3].A);
			end
		end
		
		local i = 14;
		self.Number:SetTextColor(LBColors[i].R, LBColors[i].G, LBColors[i].B, LBColors[i].A);
		local i = 15;
		self.Timer:SetTextColor(LBColors[i].R, LBColors[i].G, LBColors[i].B, LBColors[i].A);
	end
end

function Lifebloomer_GCDUpdate(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
	while self.TimeSinceLastUpdate > 0.05 do
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - 0.05;
		if LB_GCD then
			local start, duration, e = GetSpellCooldown(LIFEBLOOMER_Healing_Touch);
			local seconds = GetTime();
			self:SetValue((duration-(seconds-start))/duration);
		end
	end
end

function Lifebloomer_OnEvent(self, event, arg1)
	if event == "PLAYER_TARGET_CHANGED" then
		if self:GetAttribute("unit") == "target" then
			self.Dmg = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			self.DTPS = 0;
		end
	elseif event == "PLAYER_FOCUS_CHANGED" then
		if self:GetAttribute("unit") == "focus" then
			self.Dmg = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
			self.DTPS = 0;
		end
	end
end

function Lifebloomer_ID_Unit(unit)
	if not UnitExists(unit) then
		return "target";
	elseif UnitIsUnit(unit, "focus") then
		return "focus";
	elseif UnitIsUnit(unit, "player") then
		return "player";
	elseif UnitIsUnit(unit, "pet") then
		return "pet";
	elseif UnitInRaid(unit) or UnitInParty(unit)then
		local name, realm = UnitName(unit);
		if not ( realm == LBVrealm ) then
			name = name.."-"..realm;
		end
		return name;
	elseif UnitPlayerOrPetInRaid(unit) then
		for i=1, 40, 1 do
			if UnitIsUnit(unit, "raidpet"..i) then
				return "raidpet"..i;
			end
		end
	elseif UnitPlayerOrPetInParty(unit) then
		for i=1, 4, 1 do
			if UnitIsUnit(unit, "partypet"..i) then
				return "partypet"..i;
			end
		end
	else return "target" end
end

function Lifebloomer_AddFrame(self)
	local top = LifebloomerMainFrame:GetTop();
	local left = LifebloomerMainFrame:GetLeft();
	
	local n = self:GetParent():GetID() + 1;
	local nt = getn(LBV) + 1;
	if LBVFF == 0 then
		local NewFrame = CreateFrame("Button", "LifebloomerMainFrameUnitFrame"..nt, LifebloomerMainFrame, "LifebloomerUnitTemplate");
		NewFrame:SetID(nt);
		NewFrame:SetPoint("TOP", "LifebloomerMainFrameUnitFrame"..(nt-1), "BOTTOM", 0, -LBDim.s);
		
		NewFrame.Number = getglobal("LifebloomerMainFrameUnitFrame"..nt.."LBBarNumber");
		NewFrame.Timer = getglobal("LifebloomerMainFrameUnitFrame"..nt.."LBBarTimer");
		NewFrame.LBBar = getglobal("LifebloomerMainFrameUnitFrame"..nt.."LBBar");
		NewFrame.LBBarGCD = getglobal("LifebloomerMainFrameUnitFrame"..nt.."LBBarGCD");
		NewFrame.RejuvBar = getglobal("LifebloomerMainFrameUnitFrame"..nt.."RejuvBar");
		NewFrame.RegroBar = getglobal("LifebloomerMainFrameUnitFrame"..nt.."RegroBar");
		NewFrame.WildBar = getglobal("LifebloomerMainFrameUnitFrame"..nt.."WildBar");
		NewFrame.HPBar = getglobal("LifebloomerMainFrameUnitFrame"..nt.."HPBar");
		NewFrame.Name = getglobal("LifebloomerMainFrameUnitFrame"..nt.."HPBarName");
		NewFrame.DTPSlabel = getglobal("LifebloomerMainFrameUnitFrame"..nt.."HPBarDTPS");
		NewFrame.DTPS = 0;
		NewFrame.Damage = 0;
		NewFrame.TimeCount = 0;
		NewFrame.Dmg = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		NewFrame.LBTimer = 0;
		NewFrame.RejuvTimer = 0;
		NewFrame.RegroTimer = 0;
		NewFrame.WildTimer = 0;
		NewFrame.LBMax = 7;
		NewFrame.RejuvMax = 12;
		NewFrame.RegroMax = 21;
		NewFrame.WildMax = 7;
		
		local i = 1;
		getglobal("LifebloomerMainFrameUnitFrame"..nt):SetBackdropColor(LBColors[i].R, LBColors[i].G, LBColors[i].B, LBColors[i].A);
		local i = 2;
		getglobal("LifebloomerMainFrameUnitFrame"..nt.."HPBar"):SetStatusBarColor(LBColors[i].R, LBColors[i].G, LBColors[i].B, LBColors[i].A);
		local i = 3;
		getglobal("LifebloomerMainFrameUnitFrame"..nt.."LBBar"):SetStatusBarColor(LBColors[i].R, LBColors[i].G, LBColors[i].B, LBColors[i].A);
		local i = 4;
		getglobal("LifebloomerMainFrameUnitFrame"..nt.."RejuvBar"):SetStatusBarColor(LBColors[i].R, LBColors[i].G, LBColors[i].B, LBColors[i].A);
		local i = 5;
		getglobal("LifebloomerMainFrameUnitFrame"..nt.."RegroBar"):SetStatusBarColor(LBColors[i].R, LBColors[i].G, LBColors[i].B, LBColors[i].A);
		local i = 14;
		getglobal("LifebloomerMainFrameUnitFrame"..nt.."LBBarNumber"):SetTextColor(LBColors[i].R, LBColors[i].G, LBColors[i].B, LBColors[i].A);
		local i = 16;
		getglobal("LifebloomerMainFrameUnitFrame"..nt.."WildBar"):SetStatusBarColor(LBColors[i].R, LBColors[i].G, LBColors[i].B, LBColors[i].A);
		
		ClickCastFrames[NewFrame] = true;
		Lifebloomer_SetAttributes(NewFrame);
		Lifebloomer_SetHandlerAttributes(NewFrame);
		if Click2Cast then
			Click2Cast:RegisterFrame(NewFrame);
		end
	else
		local frame = getglobal("LifebloomerMainFrameUnitFrame"..nt);
		frame:Show();
		frame:SetAttribute("unit", "target");
		frame:RegisterEvent("PLAYER_FOCUS_CHANGED");
		frame:RegisterEvent("PLAYER_TARGET_CHANGED");
		frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		LBVFF = LBVFF - 1;
	end
	tinsert(LBV, n, {});
	LBV[n] = {};
	LBV[n].Unitid = "target";
	LBV[n].Name = "target";
	LBV[n].Realm = nil;
	
	for i=n, nt, 1 do
		Set_LBTarget(nil, LBV[i].Unitid, getglobal("LifebloomerMainFrameUnitFrame"..i));
	end
	
	LifebloomerMainFrame:ClearAllPoints();
	LifebloomerMainFrame:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", left, top);
	
	Lifebloomer_AdjustH();
	Lifebloomer_AdjustW();
	Lifebloomer_AdjustRejuv();
	Lifebloomer_AdjustRegro();
	Lifebloomer_AdjustWild();
end

function Lifebloomer_RemoveFrame(parent)
	local top = LifebloomerMainFrame:GetTop();
	local left = LifebloomerMainFrame:GetLeft();
	
	local nt = getn(LBV);
	if nt == 0 then
		LifebloomerMainFrame:Hide();
		DEFAULT_CHAT_FRAME:AddMessage(">> |cFFFFFFFFl|rife|cFFFFFFFFb|rloomer Hidden.", 0, 1, 0);
		return
	end
	local n1 = (parent):GetID();
	tremove(LBV, n1);
	for i=n1, nt-1, 1 do
		Set_LBTarget(nil, LBV[i].Unitid, getglobal("LifebloomerMainFrameUnitFrame"..i));
	end
	getglobal("LifebloomerMainFrameUnitFrame"..nt):Hide();
	getglobal("LifebloomerMainFrameUnitFrame"..nt):UnregisterEvent("PLAYER_FOCUS_CHANGED");
	getglobal("LifebloomerMainFrameUnitFrame"..nt):UnregisterEvent("PLAYER_TARGET_CHANGED");
	getglobal("LifebloomerMainFrameUnitFrame"..nt):UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	LBVFF = LBVFF + 1;
	
	LifebloomerMainFrame:ClearAllPoints();
	LifebloomerMainFrame:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", left, top);
	LifebloomerMainFrame:SetHeight(LifebloomerMainFrame:GetHeight() - (LBDim.h + LBDim.s));
end

function Lifebloomer_SlashCommand(cmd)
	if cmd == "reset" or cmd == "r" then
		if not InCombatLockdown() then
			DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFr|reset |cFFFFFFFF - Reset|r", 0, 1, 0);
			LifebloomerMainFrame:ClearAllPoints();
			LifebloomerMainFrame:SetPoint("TOP", "UIParent", "CENTER");
		end
	elseif cmd == "show" or cmd == "s" then
		if not InCombatLockdown() then
			DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFs|rhow |cFFFFFFFF - Show|r", 0, 1, 0);
			LifebloomerMainFrame:Show();
		end
	elseif cmd == "hide" or cmd == "h" then
		if not InCombatLockdown() then
			DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFh|ride |cFFFFFFFF - Hide|r", 0, 1, 0);
			LifebloomerMainFrame:Hide();
		end
	elseif cmd == "lock" or cmd == "l" then
		DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFl|rock |cFFFFFFFF - Lock|r", 0, 1, 0);
		if LBSaved.Lock then
			LBSaved.Lock = nil;
			if not InCombatLockdown() then
				LifebloomerMainFrameText:Show();
				LifebloomerMainFrame:EnableMouse(true);
				LifebloomerMainFrameReduceButton:Show();
				LifebloomerMainFrameIncreaseButton:Show();
				for i=1, #(LBV), 1 do
					getglobal("LifebloomerMainFrameUnitFrame"..i.."TargetButton"):Show();
					getglobal("LifebloomerMainFrameUnitFrame"..i.."ReduceButton"):Show();
					getglobal("LifebloomerMainFrameUnitFrame"..i.."IncreaseButton"):Show();
				end
			end
		else
			LBSaved.Lock = 1;
			if not InCombatLockdown() then
				LifebloomerMainFrameText:Hide();
				LifebloomerMainFrame:EnableMouse(false);
				LifebloomerMainFrameReduceButton:Hide();
				LifebloomerMainFrameIncreaseButton:Hide();
				for i=1, getn(LBV), 1 do
					getglobal("LifebloomerMainFrameUnitFrame"..i.."TargetButton"):Hide();
					getglobal("LifebloomerMainFrameUnitFrame"..i.."ReduceButton"):Hide();
					getglobal("LifebloomerMainFrameUnitFrame"..i.."IncreaseButton"):Hide();
				end
			end
		end
	elseif (cmd == "party" or cmd == "p") and (not InCombatLockdown()) then
		DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFp|rarty |cFFFFFFFF - Generate Party Frames|r", 0, 1, 0);
		local n = getn(LBV);
		local np = GetNumPartyMembers() + 1;
		if n > np then
			for i = 1, n - np, 1 do
				Lifebloomer_RemoveFrame(LifebloomerMainFrameUnitFrame1);
			end
		elseif n < np then
			for i = 1, np - n, 1 do
				Lifebloomer_AddFrame(LifebloomerMainFrameUnitFrame1);
			end
		end
		local id = "player";
		LBV[1].Unitid = id;
		LBV[1].Name = UnitName(id);
		Set_LBTarget(nil, id, getglobal("LifebloomerMainFrameUnitFrame1"));
		local j = 2;
		for i = 1, np-1, 1 do
			if GetPartyMember(i) then
				local id = "party"..i;
				LBV[j].Unitid = id;
				LBV[j].Name = UnitName(id);
				Set_LBTarget(nil, id, getglobal("LifebloomerMainFrameUnitFrame"..j));
				j = j + 1;
			end
		end
	else
		Lifebloomer_CommandList();
	end
end

function Lifebloomer_CommandList()
	DEFAULT_CHAT_FRAME:AddMessage("Commands:", 1, 1, 1);
	DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFF - Command List|r", 0, 1, 0);
	DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFs|rhow |cFFFFFFFF - Show|r", 0, 1, 0);
	DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFh|ride |cFFFFFFFF - Hide|r", 0, 1, 0);
	DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFr|reset |cFFFFFFFF - Reset|r", 0, 1, 0);
	DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFl|rock |cFFFFFFFF - Lock|r", 0, 1, 0);
	DEFAULT_CHAT_FRAME:AddMessage("/|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFp|rarty |cFFFFFFFF - Generate Party Frames|r", 0, 1, 0);
end

function Lifebloomer_DamageTaken(self, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing)
	if arg2 == "SWING_DAMAGE" then
		self.Damage = self.Damage + spellId;
	elseif arg2 == "ENVIRONMENTAL_DAMAMGE" then
		self.Damage = self.Damage + spellName;
	else
		self.Damage = self.Damage + amount;
	end
end

function Lifebloomer_DamageTakenUpdate1(self)
	self.DTPS = self.DTPS * 0.8 + self.Damage * 0.4;
	self.Damage = 0;
	self.DTPSlabel:SetText(tostring(floor(self.DTPS)));
	if UnitIsUnit(LBV[self:GetID()].Unitid, LBV[self:GetID()].Target2) then
		self.DTPSlabel:SetTextColor(LBColors[12].R, LBColors[12].G, LBColors[12].B, LBColors[12].A);
	else self.DTPSlabel:SetTextColor(LBColors[13].R, LBColors[13].G, LBColors[13].B, LBColors[13].A); end
end


function Lifebloomer_DamageTakenUpdate2(self)
	tinsert(self.Dmg, 1, self.Damage);
	tremove(self.Dmg, 13);
	self.Damage = 0;
	self.DTPS = ( self.Dmg[1] + self.Dmg[2] + self.Dmg[3] + self.Dmg[4] + self.Dmg[5] + self.Dmg[6] + self.Dmg[7] + self.Dmg[8] + self.Dmg[9] + self.Dmg[10] + self.Dmg[11] + self.Dmg[12] ) / 6;
	self.DTPSlabel:SetText(tostring(floor(self.DTPS)));
	if UnitIsUnit(LBV[self:GetID()].Unitid, LBV[self:GetID()].Target2) then
		self.DTPSlabel:SetTextColor(LBColors[12].R, LBColors[12].G, LBColors[12].B, LBColors[12].A);
	else self.DTPSlabel:SetTextColor(LBColors[13].R, LBColors[13].G, LBColors[13].B, LBColors[13].A); end
end

function Lifebloomer_deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end

function Lifebloomer_UIDropdownMenu_OnLoad(self)
	local cb_init_fn = function()
		local info;
		info = {};
		info.text = LIFEBLOOMER_None;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 1, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Target;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 2, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Lifebloom;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 3, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Rejuvenation;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 4, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Regrowth;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 5, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Healing_Touch;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 6, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Nourish;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 7, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Swiftmend;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 8, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Wild_Growth;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 9, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Cure_Poison;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 10, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Abolish_Poison;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 11, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Remove_Curse;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 12, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Rebirth;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 13, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Mark_of_the_Wild;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 14, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Thorns;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 15, 0); end
		UIDropDownMenu_AddButton(info);
		info = {};
		info.text = LIFEBLOOMER_Natures_Swiftness;
		info.func = function() UIDropDownMenu_SetSelectedID(self, 16, 0); end
		UIDropDownMenu_AddButton(info);
	end
	UIDropDownMenu_Initialize(self, cb_init_fn);
end